
C_WowTokenPublic.UpdateMarketPrice()

local SecondsToAMonth = ((30 *24)*60)*60;
GoldTimedataResults = {};

if(GoldTimeExchangeRate == nil) then
  GoldTimeExchangeRate = 2000; --1500 for GBP 2000 for USD and EUR
end
if(GoldTimeExchangeSymbol == nil) then
  GoldTimeExchangeSymbol = "€"
end
if(GoldTimeShowGameTime == nil) then
  GoldTimeShowGameTime = true
end
if(GoldTimeShowValue == nil) then
  GoldTimeShowValue = true
end

OrgTimeLeftString = "Game Time";
OrgGoldleftString = "Real Value"

StackSize = 0;


local function OnTooltipSetItem(self, itemString)
   local name, link = self:GetItem()
    
    if not link then
        return
    end

   local itemName, itemLink, itemRarity, itemLevel, itemMinLevel, itemType, itemSubType, itemStackCount, itemEquipLoc, itemTexture, itemSellPrice = GetItemInfo(link)
   local TimeleftString = "Game Time"
   local GoldleftString = "Real Value"
   itemSellPrice = nil;

   -- TSM support
    if IsAddOnLoaded("TradeSkillMaster_AuctionDB") then
      local f = TSMAPI.GetItemValue(link,"wowuctionMarket");
      itemSellPrice=f;
      GoldleftString = OrgGoldleftString.." (wowuctionMarket)"
      TimeleftString = OrgTimeLeftString.." (wowuctionMarket)"

      local f = TSMAPI:GetItemValue(link,"DBMarket");
      itemSellPrice=f;
      GoldleftString = OrgGoldleftString.." (DBMarket)"
      TimeleftString = OrgTimeLeftString.." (DBMarket)"
    end

   -- TUJ support
    if IsAddOnLoaded("TheUndermineJournal") and not itemSellPrice then
      TUJMarketInfo(itemLink, GoldTimedataResults);
      itemSellPrice = GoldTimedataResults["market"];
      GoldleftString = OrgGoldleftString.." (TUJMarket)"
      TimeleftString = OrgTimeLeftString.." (TUJMarket)"
    end

   -- Auctioneer support
    if IsAddOnLoaded(string.lower("Auc-Advanced")) and not itemSellPrice then
      auctioneerSellPrice, _ = AucAdvanced.API.GetMarketValue(itemLink, AucAdvanced.GetFaction());
      if auctioneerSellPrice then
          itemSellPrice = auctioneerSellPrice
          GoldleftString = OrgGoldleftString.." (AUCMarket)"
          TimeleftString = OrgTimeLeftString.." (AUCMarket)"
      end
    end

    if itemSellPrice and itemSellPrice > 0 then
        -- Item has a sell price

        if(GoldTimeShowGameTime) then
          --Time
          SecondsPerCopper =  C_WowTokenPublic.GetCurrentMarketPrice() / SecondsToAMonth
          realPrice = itemSellPrice / SecondsPerCopper
          realPrice = math.floor(realPrice + 0.5)
          if(IsShiftKeyDown()) then
            realPrice = realPrice*StackSize;
            TimeleftString = TimeleftString.." x"..StackSize;
          end
          if realPrice < 1 then
              GameTooltip:AddDoubleLine(TimeleftString, "<1s", 1, 1, 0, 0.5, 0.5, 0.5)
          else
            local st = "";
            if(math.floor(realPrice%60) > 0) then
              st = math.floor((realPrice%60)).."s"..st;
            end
            if(math.floor(realPrice/60%60) > 0) then
              st = math.floor((realPrice/60%60)).."m"..st;
            end
            if(math.floor(realPrice/(60*60)%24) > 0) then
              st = math.floor((realPrice/(60*60)%24)).."h"..st;
            end
            if(math.floor(realPrice/((60*60)*24)) > 0) then
              st = math.floor((realPrice/((60*60)*24))).."d "..st;
            end
              GameTooltip:AddDoubleLine(TimeleftString, st, 1, 1, 0, 1, 1, 0)
          end
        end


        if(GoldTimeShowValue) then
          --Currency
          exchangeRate =  C_WowTokenPublic.GetCurrentMarketPrice() / GoldTimeExchangeRate 
          realPrice = itemSellPrice / exchangeRate
          realPrice = math.floor(realPrice + 0.5) / 100 
          if(IsShiftKeyDown()) then
            realPrice = realPrice*StackSize;
            GoldleftString = GoldleftString.." x"..StackSize;
          end
          if realPrice < 0.01 then
              GameTooltip:AddDoubleLine(GoldleftString, "<$0.01", 1, 1, 0, 0.5, 0.5, 0.5)
          else
              GameTooltip:AddDoubleLine(GoldleftString, GoldTimeExchangeSymbol.. string.format("%.2f", realPrice), 1, 1, 0, 1, 1, 0)
          end
        end


        cleared = true
    end
end
GameTooltip:HookScript("OnTooltipSetItem", OnTooltipSetItem)
C_Timer.NewTicker(301, C_WowTokenPublic.UpdateMarketPrice)

 --This Hook Does Standard Bad Items
 hooksecurefunc (GameTooltip, "SetBagItem",
 function(tip, whichbag, whichslot)
 _, StackSize = GetContainerItemInfo(whichbag, whichslot);
 end
 );

 --This Hook Does The Bank Objects
 hooksecurefunc (GameTooltip, "SetInventoryItem",
 function (tip, whichunit, whichslot)
 StackSize=GetInventoryItemCount(whichunit,whichslot)
 end
 );

local function cmdHandler(message, editbox)
    DEFAULT_CHAT_FRAME:AddMessage(message);
    if(message == "" or message == nil) then
      DEFAULT_CHAT_FRAME:AddMessage("GoldTime Help\n"
        .."Change symbol: Current:"..GoldTimeExchangeSymbol.."\n"
        .."/gt symbol X\n"
        .."Change Currencyrate: Current:"..GoldTimeExchangeRate.."\n"
        .."Suggested Rates (1500 GBP) (2000 USD) (2000 EUR)\n"
        .."/gt rate XXXX\n"
        .."Toggle Gametime with:\n"
        .."/gt gametime\n"
        .."Toggle Currency value with:\n"
        .."/gt value\n"
        );
    end
    if(string.find(string.lower(message), "symbol")) then
      local f, value = strsplit(" ", message);
      DEFAULT_CHAT_FRAME:AddMessage("Setting symbol to:"..value);
      GoldTimeExchangeSymbol = value;
    elseif(string.find(string.lower(message), "rate")) then
      local f, value = strsplit(" ", message);
      if(tonumber(value)) then
        DEFAULT_CHAT_FRAME:AddMessage("Setting rate to:"..value);
        GoldTimeExchangeRate = tonumber(value);
      else
        DEFAULT_CHAT_FRAME:AddMessage("Must be a number");
      end
    end

    if(string.lower(message) == "gametime") then
      if(GoldTimeShowGameTime == true) then
        GoldTimeShowGameTime = false;
        DEFAULT_CHAT_FRAME:AddMessage("Gametime turned off");
      else
        GoldTimeShowGameTime = true;
        DEFAULT_CHAT_FRAME:AddMessage("Gametime turned on");
      end
    elseif(string.lower(message) == "value") then
      if(GoldTimeShowValue == true) then
        DEFAULT_CHAT_FRAME:AddMessage("Value turned off");
        GoldTimeShowValue = false;
      else
        GoldTimeShowValue = true;
        DEFAULT_CHAT_FRAME:AddMessage("Value turned on");
      end
    end

end

SLASH_GOLDTIME1, GOLDTIME2 = '/gt', '/goldtime';
SlashCmdList["GOLDTIME"] = function(message, editbox) cmdHandler(message, editbox) end
